(* week-13_modules.ml *)
(* Introduction to Computer Science (YSC1212), Sem1, 2020-2021 *)
(* Olivier Danvy <danvy@yale-nus.edu.sg> *)
(* Version of Sat 03 Apr 2021 *)

(* ********** *)

module First_v0 =
  struct
    let b = true
    let n = 33
  end;;

(* ********** *)

(* Exercise 8: *)

module Zeroth_v0 =
  struct
  end;;

(*
   # module Zeroth_v0 =
       struct
       end;;
   module Zeroth_v0 : sig  end
   # 
*)

(* Answer:
   The structure and the signature are both empty.
*)

(* ********** *)

module Second_v0 =
  struct
    let b = true
    let n = 33
    let i = n + 11
  end;;

(* ********** *)

module Third_v0 =
  struct
    let b = true
    let n = 33
    let i = n + 11
    let i = n
    and n = i
    and b' = i < n
  end;;

(*
   # module Third_v0 =
       struct
         let b = true
         let n = 33
         let i = n + 11
         let i = n
         and n = i
         and b' = i < n
       end;;
   
   module Third_v0 : sig val b : bool val i : int val n : int val b' : bool end
   #   
*)

(* ********** *)

module Fourth_v0 =
  struct 
    let x = 10
    module July =
      struct
        let y = 20
      end
    let z = 30
  end;;

(*
   # module Fourth_v0 =
       struct 
         let x = 10
         module July =
           struct
             let y = 20
           end
         let z = 30
       end;;
   module Fourth_v0 : sig val x : int module July : sig val y : int end val z : int end
   # 
*)

(* ********** *)

(* Exercise 9: *)

module Quatorze =
  struct 
    let x = 10
    module Juillet =
      struct
      end
    let z = 30
  end;;

(*
   # module Quatorze =
     struct 
       let x = 10
       module Juillet =
         struct
         end
       let z = 30
     end;;
   module Quatorze : sig val x : int module Juillet : sig  end val z : int end
   # 
*)

(* NB:
   The signature of Juillet, in the signature of Quatorze, is empty.
*)

(* ********** *)

module type FIRST =
  sig
    val b : bool
    val n : int
  end;;

module First_v1 : FIRST =
  struct
    let b = true
    let n = 33
  end;;

(*
   # module First_v1 : FIRST =
     struct
       let b = true
       let n = 33
     end;;
   module First_v1 : FIRST
   # 
*)

(* ********** *)

(* Exercise 10: *)

module type ZEROTH =
  sig
  end;;

module Zeroth_v1 : ZEROTH =
  struct
  end;;

(*
   # module type ZEROTH =
       sig
       end;;
   module type ZEROTH = sig  end
   # module Zeroth_v1 : ZEROTH =
       struct
       end;;
   module Zeroth_v1 : ZEROTH
   # 
*)

(* ********** *)

module type SECOND =
  sig
    val b : bool
    val n : int
    val i : int
  end;;

module Second_v1 : SECOND =
  struct
    let b = true
    let n = 33
    let i = n + 11
  end;;

module Second_v2 : FIRST =
  struct
    let b = true
    let n = 33
    let i = n + 11
  end;;

(* ********** *)

(* Exercise 11: *)

module Second_v3 : ZEROTH =
  struct
    let b = true
    let n = 33
    let i = n + 11
  end;;

(*
   # module Second_v3 : ZEROTH =
       struct
         let b = true
         let n = 33
         let i = n + 11
       end;;
   module Second_v3 : ZEROTH
   # 
*)

(* Answer:
   OCaml accepts this declaration.
   To us users, Module Second_v3 behaves as the empty module.
*)

(* ********** *)

module Third_v1 : sig val b : bool val b' : bool end =
  struct
    let b = true
    let n = 33
    let i = n + 11
    let i = n
    and n = i
    and b' = i < n
  end;;

(* ********** *)

(* Exercise 12: *)

module Third_v2 : sig end =
  struct
    let b = true
    let n = 33
    let i = n + 11
    let i = n
    and n = i
    and b' = i < n
  end;;

(*
   # module Third_v2 : sig end =
       struct
         let b = true
         let n = 33
         let i = n + 11
         let i = n
         and n = i
         and b' = i < n
       end;;
   module Third_v2 : sig  end
   # 
*)

(* Answer:
   OCaml accepts this declaration.
   To us users, Module Third_v2 behaves as the empty module.
*)

(* ********** *)

module Second_maker_v0 =
  functor (M : FIRST) ->
  struct
    let b = M.b
    let n = M.n
    let i = n + 11
  end;;

module Second_maker_v1 (M : FIRST) =
  struct
    let b = M.b
    let n = M.n
    let i = n + 11
  end;;

module Second_v4 = Second_maker_v0 (First_v1);;

module Second_v5 : SECOND = Second_maker_v0 (First_v1);;

module Second_v6 : FIRST = Second_maker_v0 (First_v1);;

(* ********** *)

(* Exercise 13: *)

module Second_v7 : ZEROTH = Second_maker_v0 (First_v1);;

module Second_v8 : sig end = Second_maker_v0 (First_v1);;

(*
   # module Second_v7 : ZEROTH = Second_maker_v0 (First_v1);;
   module Second_v7 : ZEROTH
   # module Second_v8 : sig end = Second_maker_v0 (First_v1);;
   module Second_v8 : sig  end
   # 
*)

(* Answer:
   OCaml accepts these two declarations.
   To us users, these modules behave as the empty module.
*)

(* ********** *)

module Compound_maker_maker =
  functor (X : sig val x : int end) ->
  functor (Y : sig val y : int end) ->
  struct
    let x = X.x
    let y = Y.y
  end;;

module Compound_maker =
  Compound_maker_maker (struct let x = 10 end);;

module Compound =
  Compound_maker (struct let y = 20 end);;

module Compound_alt =
  Compound_maker_maker (struct let x = 10 end) (struct let y = 20 end);;

(* ***** *)

module Compound_maker_maker' (X : sig val x : int end) (Y : sig val y : int end) =
  struct
    let x = X.x
    let y = Y.y
  end;;

module Compound_maker' =
  Compound_maker_maker' (struct let x = 10 end);;

module Compound' =
  Compound_maker' (struct let y = 20 end);;

module Compound_alt' =
  Compound_maker_maker' (struct let x = 10 end) (struct let y = 20 end);;

(* ********** *)

module Full_of_emptiness (F : functor (M : sig end) -> sig end) =
  F (struct end);;

(* ********** *)

(* end of week-13_modules.ml *)

let end_of_file = "week-13_modules.ml";;

(*
           OCaml version 4.01.0
   
   # #use "week-13_modules.ml";;
   module First_v0 : sig val b : bool val n : int end
   module Zeroth_v0 : sig  end
   module Second_v0 : sig val b : bool val n : int val i : int end
   module Third_v0 : sig val b : bool val i : int val n : int val b' : bool end
   module Fourth_v0 : sig val x : int module July : sig val y : int end val z : int end
   module Quatorze : sig val x : int module Juillet : sig  end val z : int end
   module type FIRST = sig val b : bool val n : int end
   module First_v1 : FIRST
   module type ZEROTH = sig  end
   module Zeroth_v1 : ZEROTH
   module type SECOND = sig val b : bool val n : int val i : int end
   module Second_v1 : SECOND
   module Second_v2 : FIRST
   module Second_v3 : ZEROTH
   module Third_v1 : sig val b : bool val b' : bool end
   module Third_v2 : sig  end
   module Second_maker_v0 : functor (M : FIRST) -> sig val b : bool val n : int val i : int end
   module Second_maker_v1 : functor (M : FIRST) -> sig val b : bool val n : int val i : int end
   module Second_v4 : sig val b : bool val n : int val i : int end
   module Second_v5 : SECOND
   module Second_v6 : FIRST
   module Second_v7 : ZEROTH
   module Second_v8 : sig  end
   module Compound_maker_maker : functor (X : sig val x : int end) -> functor (Y : sig val y : int end) -> sig val x : int val y : int end
   module Compound_maker : functor (Y : sig val y : int end) -> sig val x : int val y : int end
   module Compound : sig val x : int val y : int end
   module Compound_alt : sig val x : int val y : int end
   module Compound_maker_maker' : functor (X : sig val x : int end) -> functor (Y : sig val y : int end) -> sig val x : int val y : int end
   module Compound_maker' : functor (Y : sig val y : int end) -> sig val x : int val y : int end
   module Compound' : sig val x : int val y : int end
   module Compound_alt' : sig val x : int val y : int end
   module Full_of_emptiness : functor (F : functor (M : sig  end) -> sig  end) -> sig  end
   val end_of_file : string = "week-13_modules.ml"
   # 
*)
